Subject: Re: Invalid Argument when adding a bond to a bridge

From: Stephen Hemminger <[email-masked]>
Date: Thu, 22 Dec 2011 08:45:21 -0800

On Thu, 22 Dec 2011 08:25:54 -0600
Dyweni - NetDev <[email-masked]> wrote:

>  Hi All,
> 
>  I need some help figuring this one out... Whenever I try to add a bond 
>  to a
>  bridge, I get back an invalid argument error. I've confirmed this on
>  3.2-rc6, 3.1.5, 3.0.13, and 2.6.39.4 (haven't checked earlier kernels).
> 
>  Here's my setup: 32bit KVM virtual machine with no network cards (... 
>  -net
>  none ... ).
> 
>  I created the bond with: echo "+x" > /sys/class/net/bonding_masters
> 
>  I created the bridge with: brctl addbr b
> 
>  I try to add the bond to the bridge with: brctl addif b x
> 

The bonding device inherits its MAC address from the slave
devices. Therefore until the you add a slave to the bonding device
it's MAC address isn't set (all zeros). Bridging is not allowed
without a valid MAC address.

The solution is to fully configure the bonding device before adding
to the bridge.